﻿/*
    Program Morseovka
    ========================================================
    Matyas Vohralik, 2016
    Krouzek programovani, Gymnazium Dr. Emila Holuba, Holice
    Program je freeware
    ========================================================
    Zadani: vytvorte program, ktery si na vstupu precte text (v latince), ktery nasledne prevede do znaku Morseovy abecedy podle nasledujicich pravidel:
    1) jednotliva pismena budou oddelena na konci lomitkem /
    2) jednotliva slova budou na konci oddelena dvema lomitky //
    3) program bude umet kodovat vsechny tyto znaky: a,b,c,d,e,f,g,h,ch,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z,0,1,2,3,4,5,6,7,8,9,?,carka,!,.,;,/,=,-,tabulator,(,),",:,_,@,Ä,Ë,Ö,Ü
    4) na konci vypisu Morseova kodu napise toto " /KONEC/"
    5) Po vypisu kodu se program dotaze uzivatele, jestli chce dany kod prehrat. Pokud uzivatel odpovi kladne, program mu prehraje dany Morseuv kod a v pripade neznameho znaku pouzije jiny zvuk
    6) program bude opakovatelny
    7) pokud uzivatel zada nedefinovany znak, bude nahrazen otaznikem a varovnym zvukem
    -------------------------
    Poznamka: pozor na pismeno ch - to ma v Morseove abecede svuj vlastni znak!
*/

using System; // zadna dalsi knihovna neni potreba

namespace Morseovka
{
    class Program
    {
        // vytvorime si 3 prehravace pro jednotlive zvuky - je to lepsi nez jednomu stale menit zvuk
        static System.Media.SoundPlayer prehravac_tecka = new System.Media.SoundPlayer(Properties.Resources.tecka);
        static System.Media.SoundPlayer prehravac_carka = new System.Media.SoundPlayer(Properties.Resources.carka);
        static System.Media.SoundPlayer prehravac_mezera = new System.Media.SoundPlayer(Properties.Resources.mezera);
        static System.Media.SoundPlayer prehravac_nedefinovany_znak = new System.Media.SoundPlayer(Properties.Resources.nedefinovany_znak);

        static void Main(string[] args)
        {
            Console.Title = "Morseovka";
            // pole obsahujici kody Morseovy abecedy
            // nize jsou naznaceny indexy pole a prislusne znaky latinky (vsimnete si, ze pismeno ch je az na konci abecedy - duvod nize)
            //                                         0     1      2      3    4    5      6     7     8      9    10     11    12    13  14     15     16    17    18   19   20     21    22     23     24     25  |  26  |  27      28      29      30      31      32      33      34      35      36   |   37       38       39       40       41      42      43       44       45      46       47       48       49       50       51   |  52     53      54     55
            //                                         a     b      c      d    e    f      g     h     i      j     k      l     m     n   o      p      q     r     s    t    u      v     w      x      y      z  |  ch  |   0       1       2       3       4       5       6       7       8       9   |    ?        ,        !        .        ;       /       =        -      tab.      (        )        "        :        _        @   |   Ä      Ë       Ö      Ü
            string[] morseova_abeceda = new string[] {".-","-...","-.-.","-..",".","..-.","--.","....","..",".---","-.-",".-..","--","-.","---",".--.","--.-",".-.","...","-","..-","...-",".--","-..-","-.--","--..","----","-----",".----","..---","...--","....-",".....","-....","--...","---..","----.","..--..","--..--","--...-",".-.-.-","-.-.-.","-..-.","-...-","-....-",".----.","-.--.","-.--.-",".-..-.","---...","..--.-",".--.-.",".-.-","..-..","---.","..--"};
            string vstup, vystup = ""; // text k zakodovani (vstup) a zakodovany text (vystup)
            // abychom mohli do promenne vystup pridavat dalsi znaky (+=), nesmi v ni byt hodnota null. Dame tam proto prazdny string (to neni null)
            UInt16 kod_znaku; // promenna pro uchovani kodu jednotliveho ASCII znaku
            ConsoleKey klavesa; // promenna pro zjisteni, ktera klavesa byla zmacknuta (bude potreba na konci)

            start:
            Console.WriteLine("Zadejte text k zakódování do Morseovy abecedy:");
            vstup = Console.ReadLine();

            // prevedeme vsechno na mala pismena (morseovka nerozlisuje velikosti)
            vstup = vstup.ToLower();
            // musime pouzit for (ne foreach), protoze pokud narazime na pismeno c, musime se podivat za nej, jestli tam neni h - to by pak bylo ch.
            // proto musime znat index aktualniho analyzovaneho pismena
            for(UInt16 index = 0; index < vstup.Length; index++)
            {
                kod_znaku = Convert.ToUInt16(vstup[index]);
                // nejprve si prevedeme znak na kod a ulozime do promenne. Proc? Pokud bychom museli pokazde znak prevadet pomoci Convert, zatezovalo by to pocitac
                // podminky umyslne radime od nejpravdepodobnejsi po nejmene pravdepodobnou - je zbytecne aby program resil nejprve nepravdepodobne podminky

                if (kod_znaku >= 97 && kod_znaku <= 122) // jedna se o pismeno od a (97) do z (122) (bez ch)
                {
                    if (kod_znaku == 'c') // je to pismeno c (ASCII kod 99)?
                    {
                        if (index != (vstup.Length - 1)) // pokud je pismeno c zrovna na konci radku, uz neni zadny dalsi znak za nim - nemuzeme se tedy divat za nej, nastala by chyba
                        {
                            if (vstup[index + 1] == 'h') // je za nim pismeno h?
                            {
                                // potom je tato dvojice pismenem ch
                                vystup += morseova_abeceda[26]; // na indexu 26 je kod pro pismeno ch
                                index++; // musime se explicitne posunout dal, protoze pismeno ch je ze dvou pismen a uz jsme ho vyresili
                            }
                            else // za c neni h - v tom pripade to neni ch
                            {
                                vystup += morseova_abeceda[2]; // Morseuv kod pismena c
                            }
                        }
                        else // za pismenem c uz nic neni - v tom pripade to nemuze byt ch
                        {
                            vystup += morseova_abeceda[2]; // Morseuv kod pismena c
                        }
                    }
                    else
                    {
                        // tak potom to je jednoduche - Morseovy kody pro pismena a-z jsou hned na zacatku pole
                        vystup += morseova_abeceda[vstup[index] - 97]; // na konec pridat oddelovac
                    }
                }
                else if (kod_znaku >= 48 && kod_znaku <= 57) // jedna se o cislo?
                {
                    vystup += morseova_abeceda[vstup[index] - 21];
                }
                else
                {
                    switch (vstup[index])
                    {
                        case ' ': break; // mezera (konec slova) - dle zadani oddelit lomitkem (nepridavat nic, lomitko se pridava vzdy)
                        case '?': vystup += morseova_abeceda[37]; break;
                        case ',': vystup += morseova_abeceda[38]; break;
                        case '!': vystup += morseova_abeceda[39]; break;
                        case '.': vystup += morseova_abeceda[40]; break;
                        case ';': vystup += morseova_abeceda[41]; break;
                        case '/': vystup += morseova_abeceda[42]; break;
                        case '=': vystup += morseova_abeceda[43]; break;
                        case '-': vystup += morseova_abeceda[44]; break;
                        case '	': vystup += morseova_abeceda[45]; break; // tabulator POZOR! ve Visual Studiu to nenapise tabulator, ale 2 mezery! Vytvorte si proto tabulator v poznamkovem bloku a zkopirujte ho sem
                        case '(': vystup += morseova_abeceda[46]; break;
                        case ')': vystup += morseova_abeceda[47]; break;
                        case '"': vystup += morseova_abeceda[48]; break;
                        case ':': vystup += morseova_abeceda[49]; break;
                        case '_': vystup += morseova_abeceda[50]; break;
                        case '@': vystup += morseova_abeceda[51]; break;
                        case 'ä': vystup += morseova_abeceda[52]; break;
                        case 'ë': vystup += morseova_abeceda[53]; break;
                        case 'ö': vystup += morseova_abeceda[54]; break;
                        case 'ü': vystup += morseova_abeceda[55]; break;
                        default: vystup += '?'; break; // nedefinovany znak
                    }
                }
                vystup += '/'; // oddelovac nemusim pridavat pokazde, ale staci na konci kazdeho kodu
            }
            Console.WriteLine("Zde je zašifrovaná zpráva: " + vystup + " /KONEC/");
            Console.WriteLine("Přejete si přehrát tento Morseův kód? (pokud ANO, zmáčkněte MEZERNÍK, pokud NE, zmáčkněte ENTER, program ukonšíte stiskem kterékoli jiné klávesy)");
            
            klavesa = Console.ReadKey().Key;

            if (klavesa == ConsoleKey.Spacebar) // nechceme prehrat
            {
                vystup = ""; // musime smazat vystup - vstup se premaze novym zadanim, ale vystup musime premazat takto
                Console.Clear(); // smazeme konzoli
                goto start; // nekonecna smycka
            }
            else if (klavesa == ConsoleKey.Enter) // chceme prehrat
            {
                prehrat(vystup);
                Console.ReadKey();
                vystup = "";
                Console.Clear();
                goto start;
            }
        }

        // metoda pro prehrani zvuku - vstupnim parametrem je kod (string)
        static void prehrat(string kod)
        {
            // musime pozit opet for, protoze je potreba rozlisovat jedno lomitko u ktereho neni prodleva, ale 2 lomitka znamenaji konec slova - casova prodleva
            for(UInt16 index = 0; index < kod.Length; index++)
            {
                switch (kod[index])
                {
                    case '.':
                        Console.Write('.'); // pak ho ukazeme
                        prehravac_tecka.PlaySync(); // a nakonec ho spustime (PlaySync() zaridi, ze program pocka, nez zvuk dohraje - narozdil od Play())
                        break;
                    case '-':
                        Console.Write('-');
                        prehravac_carka.PlaySync(); // a nakonec ho spustime
                        break;
                    case '?':
                        Console.Write('?');
                        prehravac_nedefinovany_znak.PlaySync(); // a nakonec ho spustime
                        break;
                    case '/':
                        Console.Write('/');
                        if (index != (kod.Length - 1)) // aby nenastala chyba u posledniho znaku
                        {
                            if (kod[index + 1] == '/') // pokud nasleduje jeste jedno lomitko, jedna se o konec slova a musi se udelat prodleva
                            {
                                Console.Write('/');
                                prehravac_mezera.PlaySync();
                                index++;
                            }
                        }
                        break;
                }
            }
            Console.WriteLine(" /KONEC/");
        }
    }
}
